#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2six4search.py">
#<abstract4xi abstract = "shoots to direction six"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2six4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2six4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2six4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4six

global count2ack4six
global count2nack4six
global count2found4six
global count2short4six

global current2series4six
global candidate2series4six

global fileobject4six  

global keys2profile4six
global key2profile4six

global left2find4six

global maxsize2ack4six    
global maxsize2file4six 
global max2short4six
global meansize2ack4six
global minsize2ack4six

global six2analyse4search

global profile2fetch4six

global right2find4six

global sumsize2ack4six    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4six = VersionKB4Xi['base2shoot4six']             # base internet address, None=local url

count2ack4six   = 0
count2nack4six  = 0
count2found4six = 0
count2short4six = 0

left2find4six = '('

max2short4six = VersionKB4Xi['max2short4six']
maxsize2file4six = VersionKB4Xi['maxsize2file4six']
maxsize2ack4six  = 0
meansize2ack4six = 0
minsize2ack4six  = 0

current2series4six = "current2series4six5dummy"
candidate2series4six  = "candidate2series4six5dummy"


six2analyse4search  = VersionKB4Xi['six2analyse4search']

profile2fetch4six = {}
profile2fetch4six [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4six [2] = '.jpg'
keys2profile4six = profile2fetch4six.keys()

right2find4six = ')'

sumsize2ack4six  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4six" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4six(target2explore4six):
    global count2ack4six
    global count2nack4six
    global count2found4six
    global count2short4six
    
    global fileobject4six 
       
    global keys2profile4six
    global key2profile4six
    
    global left2find4six

    global max2short4six    
    global maxsize2file4six     
    global maxsize2ack4six    
    global meansize2ack4six
    global minsize2ack4six
  
    global candidate2series4six
    global current2series4six
    
    
    global profile2fetch4six                         # extension for files
    
    global right2find4six
    
    global sumsize2ack4six    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4six = count2found4six + 1
    ack2debug4six = False                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4six)
    
    ack2profile = False
    for key2profile4six in keys2profile4six:
        if name2target[1] == profile2fetch4six[key2profile4six]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2SIX4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4six
        if ack2debug4six is True:
            print("(STEP 0A/33) OF SHOOT2SIX4SEARCH - PATH2INPUT: ", path2input) 
            #  
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2SIX4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4six:
            count2nack4six = count2nack4six + 1
        else:
            count2ack4six = count2ack4six + 1
            sumsize2ack4six = sumsize2ack4six + size2file
            if size2file > maxsize2ack4six:
                maxsize2ack4six = size2file
            if ((size2file < minsize2ack4six) or (minsize2ack4six == 0)):
                print("(STEP 0B/33) OF SHOOT2SIX4SEARCH - USING MINSIZE2ACK4SIX: ", minsize2ack4six, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4SIX:  0  SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2six//d\sixfly29july2012\sixfly29july2012 (1).JPG 
                # USING MINSIZE2ACK4SIX:  3866624  SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2six//d\sixfly29july2012\sixfly29july2012 (2).JPG
                minsize2ack4six = size2file
                print("(STEP 0C/33) OF SHOOT2SIX4SEARCH - SET MINSIZE2ACK4SIX TO: ", minsize2ack4six, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4SIX TO:  3866624  = SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2six//d\sixfly29july2012\sixfly29july2012 (1).JPG
                # SET MINSIZE2ACK4SIX TO:  3538944  = SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2six//d\sixfly29july2012\sixfly29july2012 (2).JPG
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4six = target2explore4six
            if ack2debug4six is True:print("(STEP 1A/33) OF SHOOT2SIX4SEARCH - URL2WEB4SIX: ", url2web4six) 
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4six,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4six = url2web4six[0:index2edit] + string2use + url2web4six[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4six)
            shortname2web4six = name2web[0]
            if ack2debug4six is True:
                print("(STEP 1B/33) OF SHOOT2SIX4SEARCH - SHORTNAME2WEB4SIX: ", shortname2web4six)
                # 
            
            string2find4six = '/'
            ackall2found4six = False           
            while 1:
                if ackall2found4six is True:
                    break
                else:
                    index2find4six=str.find(shortname2web4six,string2find4six)   
                    if index2find4six == -1:
                        ackall2found4six = True
                    else:
                        shortname2web4six = shortname2web4six[index2find4six+1:]
                        
            if ack2debug4six is True:            
                print("(STEP 1C/33) OF SHOOT2SIX4SEARCH - SHORTNAME2WEB4SIX: ", shortname2web4six)
                # 
                
            ackall2found4six = False 
            while 1:
                if ackall2found4six is True:
                    break
                else:
                    index2left4six=str.find(shortname2web4six,left2find4six)
                    if index2left4six == -1:
                        current2series4six = shortname2web4six
                        if ack2debug4six is True:
                            print("(STEP 2A/33) OF SHOOT2SIX4SEARCH - CURRENT2SERIES4SIX: ", current2series4six) 
                            # 
                        ackall2found4six = True
                         
                    else:
                        index2right4six=str.find(shortname2web4six,right2find4six)
                        if index2right4six == -1:
                            ackall2found4six = True 
                        else:
                            candidate2series4six = shortname2web4six[0:index2left4six]
                            
                            index3find4six=str.find(shortname2web4six,current2series4six)
                            if index3find4six == -1:
                                
                                current2series4six = candidate2series4six
                                if ack2debug4six is True:
                                    print("(STEP 2B/33) OF SHOOT2SIX4SEARCH - CURRENT2SERIES4SIX: ", current2series4six) 
                                    # 
                                
                                count2short4six = 0
                                fileobject4six.write('<br />' + '\n')
                            else:
                                shortname2web4six = shortname2web4six[index2left4six:index2right4six+1]
                                if ack2debug4six is True:
                                    print("(STEP 2C/33) OF SHOOT2SIX4SEARCH - SHORTNAME2WEB4SIX: ", shortname2web4six)
                                    # 
                                
                                count2short4six = count2short4six + 1
                                if count2short4six >= max2short4six:
                                    count2short4six = 0
                                else:
                                    pass       
                            ackall2found4six = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4six is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4six.write('<br /><b>&raquo;</b><a href="' + url2web4six + '" target="_blank">' + shortname2web4six + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4six = six2analyse4search
                if ack2debug4six is True:
                    print("(STEP 3A/33) OF SHOOT2SIX4SEARCH - BASE2LOCAL4SIX: ", base2local4six)
                    #              
                ack2localtries4six = False                   
                while 1:
                    if ack2localtries4six is True:
                        break
                    else:
                        index2find4six=str.find(url2web4six,base2local4six)            
                        # 
                        #  
                        if index2find4six == -1:
                            ack2localtries4six = True
                        else:
                            if ack2debug4six is True:
                                print("(STEP 3B/33) OF SHOOT2SIX4SEARCH - BASE2BUILD4SIX: ", base2build4six)
                                # 
                            url2web4six = base2build4six + url2web4six[len(base2local4six):]
                            if ack2debug4six is True:
                                print("(STEP 3C/33) OF SHOOT2SIX4SEARCH - URL2WEB4SIX: ", url2web4six)
                                # 
                            
                            if count2short4six < 1: 
                                fileobject4six.write('<br /><b>&raquo;</b><a href="' + url2web4six + '" target="_blank">' + shortname2web4six + '</a>' + '\n')
                            else:
                                fileobject4six.write('<b>&raquo;</b><a href="' + url2web4six + '" target="_blank">' + shortname2web4six + '</a>\n')                            
                            ack2localtries4six = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2SIX4SEARCH FAILED, FILEOBJECT4SIX-WRITE-FAILED: ", str(fileobject4six), time4xi())
      
    else:
        
        count2nack4six = count2nack4six + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2six4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2six4search(queue2six = None, consumer_channel2six = None, publisher_channel2six = None, path2six = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4six
    global count2nack4six
    global count2found4six
    
    global fileobject4six    
    
    global maxsize2ack4six    
    global meansize2ack4six
    global minsize2ack4six
    global sumsize2ack4six    
    
    global maxsize2file4six 
    
    global profile2fetch4six                         # extension for files
    global keys2profile4six
    global key2profile4six

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2SIX4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2SIX4SEARCH -  QUEUE2SIX: ", queue2six)      
    # QUEUE2SIX:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2SIX4SEARCH -  CONSUMER_CHANNEL2SIX: ", consumer_channel2six)
    # CONSUMER_CHANNEL2SIX:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2SIX4SEARCH -  PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)          
    # PUBLISHER_CHANNEL2SIX:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2six is None) or (consumer_channel2six is None) or (publisher_channel2six is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2SIX4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2SIX4SEARCH - QUEUE2SIX: ", queue2six)
        print("(STEP 1C/33) OF SHOOT2SIX4SEARCH - CONSUMER_CHANNEL2SIX: ", consumer_channel2six) 
        print("(STEP 1D/33) OF SHOOT2SIX4SEARCH - PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)
        print("(STEP 1E/33) OF SHOOT2SIX4SEARCH - PATH2SIX: ", path2six)     
        
        return
 
    if (not (queue2six is None) and not(consumer_channel2six is None) and not(publisher_channel2six is None) and (path2six is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2SIX4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2SIX4SEARCH - QUEUE2SIX: ", queue2six)
        print("(STEP 2C/33) OF SHOOT2SIX4SEARCH - CONSUMER_CHANNEL2SIX: ", consumer_channel2six) 
        print("(STEP 2D/33) OF SHOOT2SIX4SEARCH - PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)
        print("(STEP 2E/33) OF SHOOT2SIX4SEARCH - PATH2SIX: ", path2six)     
        return           

    if (not (queue2six is None) and not(consumer_channel2six is None) and not(publisher_channel2six is None) and not(path2six is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2SIX4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2SIX4SEARCH - QUEUE2SIX: ", queue2six)
        # QUEUE2SIX:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2SIX4SEARCH - CONSUMER_CHANNEL2SIX: ", consumer_channel2six)
        # CONSUMER_CHANNEL2SIX:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2SIX4SEARCH - PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)
        # PUBLISHER_CHANNEL2SIX:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2SIX4SEARCH - PATH2SIX: ", path2six)
        # PATH2SIX:  F://temp//yophotos//test2six//
       
        print("(STEP 4A/33) OF SHOOT2SIX4SEARCH - STARTING TO WALK PATH2SIX: ", path2six)   
        # STARTING TO WALK PATH2SIX:  F://temp//yophotos//test2six//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4six = None
        try:
            name2index4six = "index2xxxxxxxx4yo.html"
            path2index4six = path2six + name2index4six
            print("(Step 4B/33) OF SHOOT2SIX4SEARCH - SET PATH2INDEX4SIX TO: ", path2index4six)
            # R://temp//yophotos//test//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2SIX4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4SIX: ", path2index4six)          
            #                    
        fileobject4six = None
        try:
            fileobject4six = open(path2index4six,'w')
            print("(Step 4C/33) OF SHOOT2SIX4SEARCH - OPENED OUTPUT: ", fileobject4six)
            # SHOOT2SIX4SEARCH - OPENED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2six//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 4Z2/33) OF SHOOT2SIX4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4six)         
            # 
        try:                
            fileobject4six.write('<html>\n')
            
            fileobject4six.write('<style type="text/css" media="all">\n')
            fileobject4six.write(' @import "http://www.yoursixxi.org/css/halongbay.css";\n')
            fileobject4six.write('</style> \n')
            fileobject4six.write('<p>\n')
            fileobject4six.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4six.write('<br /><a id="000">yoursix<b>&Xi;</b> @Content</a>\n')
            fileobject4six.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4six.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2SIX4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4six)         
            #      
        
        
        KB2name4six = {}
        key2name4six = 0
                 
        for file2walk in DirectoryWalker(path2six):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4six [key2name4six] = file2walk
                    print ("KB2NAME4SIX[", key2name4six, "]: ", KB2name4six [key2name4six])
                    # 
                    
                    key2name4six = key2name4six + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2SIX4SEARCH - FAILED UPDATING KB2NAME4SIX WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4six(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4six.write('<br /> \n')
            fileobject4six.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4six.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4six.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4six.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4six.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4six.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4six.write('</p>\n')
            # 
            fileobject4six.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2SIX4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4six)         
            #            
        try:    
            fileobject4six.close()
            print("(Step 4C/33) OF SHOOT2SIX4SEARCH - CLOSED OUTPUT: ", fileobject4six)         
            # SHOOT2SIX4SEARCH - CLOSED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2six//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>   
        except:
            print("(Step 4Z5/33) OF SHOOT2SIX4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4six)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2SIX4SEARCH - STARTING TO ANALYSE KB2NAME4SIX: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4SIX:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4six  = {}
        AlphaKB4six['a'] = {}
        AlphaKB4six['b'] = {}
        AlphaKB4six['c'] = {}
        AlphaKB4six['d'] = {}
        AlphaKB4six['e'] = {}
        AlphaKB4six['f'] = {}
        AlphaKB4six['g'] = {}
        AlphaKB4six['h'] = {}
        AlphaKB4six['i'] = {}
        AlphaKB4six['j'] = {}
        AlphaKB4six['k'] = {}
        AlphaKB4six['l'] = {}
        AlphaKB4six['m'] = {}
        AlphaKB4six['n'] = {}
        AlphaKB4six['o'] = {}
        AlphaKB4six['p'] = {}
        AlphaKB4six['q'] = {}
        AlphaKB4six['r'] = {}
        AlphaKB4six['s'] = {}
        AlphaKB4six['t'] = {}
        AlphaKB4six['u'] = {}
        AlphaKB4six['v'] = {}
        AlphaKB4six['w'] = {}
        AlphaKB4six['x'] = {}
        AlphaKB4six['y'] = {}
        AlphaKB4six['z'] = {} 
        keys2AlphaKB4six = AlphaKB4six.keys()
        key2AlphaKB4six  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4six = len(path2six)
        # 
        
        keys2name4six = KB2name4six.keys()
                
        for key2name4six in sorted(keys2name4six):
            # 
            name2optimize4six = KB2name4six[key2name4six]
            # 
            shortcut2level4six = name2optimize4six[len2cut4six:]
            # 
            len2shortcut4six = len(shortcut2level4six)
            if len2shortcut4six == 1:
                try:
                    # LEVEL SIX CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4six in keys2AlphaKB4six:
                        KB2level1[key2level1] = shortcut2level4six
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2SIX4SEARCH ** WARNING - SHORTCUT2LEVEL4SIX: ", shortcut2level4six, " NOT IN KEYS2ALPHAKB4SIX: ", keys2AlphaKB4six)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2SIX4SEARCH *** FAILED - SHORTCUT2LEVEL4SIX: ", shortcut2level4six)      
            else:
                try:
                    
                    string2search4six = '\\'
                    shortcut2level4six = shortcut2level4six[2:]
                    
                    index2level4six=str.find(shortcut2level4six,string2search4six)
                    if index2level4six == -1:
                         
                        KB2level2[key2level2] = shortcut2level4six
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4six = shortcut2level4six[index2level4six+1:]
                        index2level4six=str.find(shortcut2level4six,string2search4six)
                        if index2level4six == -1:
                            KB2level3[key2level3] = shortcut2level4six
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4six = shortcut2level4six[index2level4six+1:]
                            index2level4six=str.find(shortcut2level4six,string2search4six)
                            if index2level4six == -1:
                                KB2level4[key2level4] = shortcut2level4six
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4six = shortcut2level4six[index2level4six+1:]
                                index2level4six=str.find(shortcut2level4six,string2search4six)
                                if index2level4six == -1:
                                    KB2level5[key2level5] = shortcut2level4six
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4six = shortcut2level4six[index2level4six+1:]
                                    index2level4six=str.find(shortcut2level4six,string2search4six)
                                    if index2level4six == -1:
                                        KB2level6[key2level6] = shortcut2level4six
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4six = shortcut2level4six[index2level4six+1:]
                                        index2level4six=str.find(shortcut2level4six,string2search4six)
                                        if index2level4six == -1:
                                            KB2level7[key2level7] = shortcut2level4six
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4six = shortcut2level4six[index2level4six+1:]
                                            index2level4six=str.find(shortcut2level4six,string2search4six)
                                            if index2level4six == -1:
                                                KB2level8[key2level8] = shortcut2level4six
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2SIX4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4SIX: ", shortcut2level4six)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2SIX4SEARCH *** FAILED - SHORTCUT2LEVEL4SIX: ", shortcut2level4six)   
        
        print ("(Step 6A/33) OF SHOOT2SIX4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2SIX4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2SIX4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2SIX4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2SIX4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # sixfly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2SIX4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2SIX4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2SIX4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2SIX4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2SIX4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2SIX4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2SIX4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2SIX4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2SIX4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2SIX4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2SIX4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2SIX4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2SIX4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2SIX4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2SIX4SEARCH - COUNT2ACK4SIX; ", count2ack4six)
            # COUNT2ACK4SIX;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2SIX4SEARCH - COUNT2NACK4SIX; ", count2nack4six)
            # COUNT2NACK4SIX;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2SIX4SEARCH - COUNT2FOUND4SIX: ", count2found4six)
            # COUNT2FOUND4SIX:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2SIX4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2SIX4SEARCH - FOUND MAX SIZE: ", maxsize2ack4six)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2SIX4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4six)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2SIX4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4six == 0:
                meansize2ack4six = 0
                print ("(Step 7G1/33) OF SHOOT2SIX4SEARCH - MEAN SIZE SET: ", meansize2ack4six)
                #  
            else:       
                meansize2ack4six = int(sumsize2ack4six / count2ack4six)
                print ("(Step 7G2/33) OF SHOOT2SIX4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4six, ", WHERE SUMSIZE2ACK4SIX: ", sumsize2ack4six, " COUNT2ACK4SIX: ", count2ack4six)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4SIX:  10944512  COUNT2ACK4SIX:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2SIX4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4six < maxsize2file4six:
                print ("(Step 7H/33) OF SHOOT2SIX4SEARCH - MIN SIZE MET: ", minsize2ack4six)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2SIX4SEARCH ** MIN DEFINED: ", minsize2ack4six, " EQUALS TO MAXSIZE2FILE4SIX: ", maxsize2file4six)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2SIX4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2SIX4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2SIX4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2SIX4SEARCH - QUEUE2SIX: ", queue2six)
        print("(STEP 7Z3/33) OF SHOOT2SIX4SEARCH - CONSUMER_CHANNEL2SIX: ", consumer_channel2six) 
        print("(STEP 7Z4/33) OF SHOOT2SIX4SEARCH - PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)
        print("(STEP 7Z5/33) OF SHOOT2SIX4SEARCH - PATH2SIX: ", path2six)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.sixxi.com; www.yoursixxi.com; www.yoursixxi.org; www.six2xi.com/; www.six4xi.com/; www.six8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2six4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
